; lifetick.asm: The code that actually implements Life.
;
; (C) 1997 by Brian Raiter, under the terms of the GNU General Public
; License ver. 2 (or any later version, if you like).

.386p

IChing		equ	00000h
WorldBits	equ	00300h

_TEXT	segment	dword	public	'CODE'	use32
assume cs:_TEXT
endlabel:

; Offset to the LifeTickOverdrive entry point.
		dw	LifeTickOverdrive - LifeTick1stGear

; Run the Life clock forward one generation in First Gear.
LifeTick1stGear:

		mov	ebx, IChing
		mov	edx, WorldBits
		xor	edi, edi
		jmp	short loopy1
death1:		mov	esi, [edx-258]
		mov	edi, [edx+254]
		sub	esi, 010101h
		sub	edi, 090909h
		mov	[edx-258], esi
		mov	esi, [edx-2]
		mov	[edx+254], edi
		sub	esi, 090001h
		or	edi, 1
		mov	[edx-2], esi
		dec	ebp
		jmp	short reenter1
change1:	test	ah, ah
		jns	short death1
		mov	esi, [edx-258]
		mov	edi, [edx+254]
		add	esi, 010101h
		add	edi, 090909h
		mov	[edx-258], esi
		mov	esi, [edx-2]
		mov	[edx+254], edi
		add	esi, 090001h
		or	edi, 1
		mov	[edx-2], esi
		inc	ebp
		jmp	short reenter1

loopy1:		mov	bl, [edx]
		mov	ch, al
loopx1:		mov	ah, [ebx]
		inc	edx
		xor	bl, ah
		js	short change1
reenter1:	mov	[edx-1], ah
		mov	bl, [edx]
		dec	ch
		jnz	short loopx1
		add	edx, 0100h
		dec	cl
		mov	dl, ch
		jnz	short loopy1
		and	edi, 1
		db	66h
		retf

; Run the Life clock forward one generation in Overdrive.
LifeTickOverdrive:

		xor	edi, edi
		test	dl, dl
		jz	quitnow
		push	ecx
		mov	ch, bl
		mov	cl, dl
		shl	ecx, 16
		mov	cl, dl
		mov	edx, edi
		mov	dh, bl
		add	edx, WorldBits
		mov	ebx, IChing
		jmp	short loopyO
deathO:		mov	esi, [edx-258]
		mov	edi, [edx+254]
		sub	esi, 010101h
		sub	edi, 090909h
		mov	[edx-258], esi
		mov	esi, [edx-2]
		mov	[edx+254], edi
		sub	esi, 090001h
		dec	ebp
		mov	[edx-2], esi
		movzx	edi, cl
		jmp	short reenterO
changeO:	test	ah, ah
		jns	short deathO
		mov	esi, [edx-258]
		mov	edi, [edx+254]
		add	esi, 010101h
		add	edi, 090909h
		mov	[edx-258], esi
		mov	esi, [edx-2]
		mov	[edx+254], edi
		add	esi, 090001h
		inc	ebp
		mov	[edx-2], esi
		movzx	edi, cl
		jmp	short reenterO		
loopyO:		mov	bl, [edx]
		mov	ch, al
loopxO:		mov	ah, [ebx]
		inc	edx
		xor	bl, ah
		js	short changeO
reenterO:	mov	[edx-1], ah
		mov	bl, [edx]
		dec	ch
		jnz	short loopxO
		add	edx, 0100h
		test	edi, 0FFh
		mov	dl, ch
		jz	short lowerfirst
		dec	cl
		jnz	short loopyO
		jmp	short edgecalc
lowerfirst:	add	ecx, 00FF0000h
		dec	cl
		jnz	short loopyO
		pop	ebx
		push	edi
		shr	ecx, 16
		jmp	short endcalc
edgecalc:	pop	ebx
		shr	ecx, 16
		push	edi
		mov	bh, ch
		add	bh, cl
		test	ch, ch
		jz	short attop
		sub	ecx, 00FFh
attop:		dec	edi
		jz	short lowerlast
		sub	ecx, edi
		inc	cl
		jmp	short endcalc
lowerlast:	cmp	bh, bl
		jz	short endcalc
		mov	ebx, IChing
loopxend:	mov	bl, [edx]
		mov	ah, [ebx]
		mov	[edx], ah
		inc	edx
		dec	al
		jnz	short loopxend
		inc	cl
endcalc:	xor	bh, bh
		mov	bl, ch
		xor	dh, dh
		mov	dl, cl
		pop	edi
quitnow:	db	66h
		retf

_TEXT		ends 

;/* Equivalent C-ish code for the two LifeTick "functions". */
;
;BOOL LifeTick1stGear(int&	population,	/* ebp */
;		      int	cxField,	/* al */
;		      int	cyField)	/* cl */
;{
;	LPBYTE	lpCell;		/* edx */
;	int	x;		/* ch */
;	BYTE	old, new;	/* bl, al */
;	BOOL	bActive;	/* edi */
;
;	lpCell = lpWorld[0];
;	for ( ; cyField ; --cyField) {
;		for (x = cxField ; x ; --x) {
;			old = *lpCell;
;			*lpCell = new = IChing[old];
;			if (CellAlive(old ^ new)) {
;				bActive = TRUE;
;				if (CellAlive(new)) {
;					lpCell[-257] += 1;  lpCell[-256] += 1;
;					lpCell[-255] += 1;  lpCell[-1] += 1;
;					lpCell[1] += 9;     lpCell[255] += 9;
;					lpCell[256] += 9;   lpCell[257] += 9;
;					++population;
;				} else {
;					lpCell[-257] -= 1;  lpCell[-256] -= 1;
;					lpCell[-255] -= 1;  lpCell[-1] -= 1;
;					lpCell[1] -= 9;     lpCell[255] -= 9;
;					lpCell[256] -= 9;   lpCell[257] -= 9;
;					--population;
;				}
;			}
;			++lpCell;
;		}
;		lpCell = (LPBYTE)((DWORD)(lpCell + 256) & 0xFFFFFF00);
;	}
;	return bActive;		/* di */
;}
;
;BOOL LifeTickOverdrive(int&	population,	/* ebp */
;		        int	cxField,	/* al */
;		        int&	yFirst,		/* bl */
;		        int	cyField,	/* cl */
;		        int&	cyActive)	/* dl */
;{
;	LPBYTE	lpCell;		/* edx */
;	int	cyInactive;	/* edi */
;	int	y, x;		/* cl, ch */
;	BYTE	old, new;	/* bl, al */
;
;	lpCell = lpWorld[yFirst];
;	cyInactive = 0;
;	for (y = cyActive ; y ; --y) {
;		for (x = cxField ; x ; --x) {
;			old = *lpCell;
;			*lpCell = new = IChing[old];
;			if (CellAlive(old ^ new)) {
;				cyInactive = y;
;				if (CellAlive(new)) {
;					lpCell[-257] += 1;  lpCell[-256] += 1;
;					lpCell[-255] += 1;  lpCell[-1] += 1;
;					lpCell[1] += 9;     lpCell[255] += 9;
;					lpCell[256] += 9;   lpCell[257] += 9;
;					++population;
;				} else {
;					lpCell[-257] -= 1;  lpCell[-256] -= 1;
;					lpCell[-255] -= 1;  lpCell[-1] -= 1;
;					lpCell[1] -= 9;     lpCell[255] -= 9;
;					lpCell[256] -= 9;   lpCell[257] -= 9;
;					--population;
;				}
;			}
;			++lpCell;
;		}
;		lpCell = (LPBYTE)((DWORD)(lpCell + 256) & 0xFFFFFF00);
;		if (!cyInactive) {
;			++yFirst;
;			--cyActive;
;		}
;	}
;	if (!cyInactive)
;		return FALSE;	/* di */
;	if (yFirst > 0) {
;		--yFirst;
;		++cyActive;
;	}
;	--cyInactive;
;	if (cyInactive)
;		cyActive -= cyInactive - 1;
;	else if (yFirst + cyActive < cyField) {
;		++cyActive;
;		for (x = cxField ; x ; --x) {
;			*lpCell = IChing[*lpCell];
;			++lpCell;
;		}
;	}
;	return TRUE;	/* di */
;}
;

end	endlabel
